/*
 * Copyright 2012 Peter W Leong
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package biz.freshcode.b_generation;

/**
 * Generates source code for BeanBuilder.
 */
public interface BeanBuilderGenerator {
    String BUILDER_SUFFIX = "Builder";

    /**
     * Generates builder source code for the given beanClass that will have the given package.
     */
    public String generate(Class beanClass, String packageName);
}
