/*
 * Copyright 2012 Peter W Leong
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package biz.freshcode.b_generation.demo;

import java.util.Date;
import java.util.List;

/**
 * A demonstration bean.
 */
public class BgenDemo<U> {
    private String str;

    public BgenDemo() {

    }

    public BgenDemo(int a, long b) {

    }

    private BgenDemo(String s) {

    }

    public String getStr() {
        return str;
    }

    public void setStr(String str) {
        this.str = str;
    }

    public void setArr(String[] arr) {
        // nothing
    }

    public void setVarArgs(int... varArgs) {
        // nothing
    }

    public void addSimple(int arg) {
        // nothing
    }

    public BgenDemo addChain(Long arg) {
        return this;
    }

    /**
     * Special case for unusual chaining implementation like GWT's MenuBar.addItem()
     */
    public Date addChainAlt(Date arg) {
        return arg;
    }

    /**
     * Will not be on the builder.
     */
    public byte addIgnored(String arg) {
        return 0;
    }

    /**
     * Will not be on the builder.
     */
    public String setIgnored(long arg) {
        return null;
    }

    /**
     * A complex generified setter
     */
    public <T extends List<U>> void setGeneric(T t, boolean b, U u) {
        // nothing
    }
}
