/*
 * Copyright waived by Peter W Leong.
 */

package biz.freshcode.b_generation.demo;

/**
 * An example of a builder parent class that facilitates configuration loops.
 * This is supplied as an example for you to copy which helps
 * to avoid runtime dependencies.
 */
public abstract class BgenDemoConstruct<T> {
    public T builder;

    public abstract void run();

    public static class Parent<T> {
        public T construct(BgenDemoConstruct<T> c) {
            @SuppressWarnings("unchecked")
            T t = (T) this;
            c.builder = t;
            c.run();
            return t;
        }
    }
}
