/*
 * Copyright 2012 Peter W Leong
 *
 *    Licensed under the Apache License, Version 2.0 (the "License");
 *    you may not use this file except in compliance with the License.
 *    You may obtain a copy of the License at
 *
 *        http://www.apache.org/licenses/LICENSE-2.0
 *
 *    Unless required by applicable law or agreed to in writing, software
 *    distributed under the License is distributed on an "AS IS" BASIS,
 *    WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied.
 *    See the License for the specific language governing permissions and
 *    limitations under the License.
 */

package biz.freshcode.b_generation.demo;

import biz.freshcode.b_generation.BeanBuilderWriter;
import biz.freshcode.b_generation.BgenUtil;
import biz.freshcode.b_generation.DefaultBeanBuilderGenerator;

/**
 * Generates the source of a BeanBuilder.
 */
public class BgenDemoGenerator extends DefaultBeanBuilderGenerator {
    public static final Class BEAN_CLS = BgenDemo.class;  //<<<<<<<<<<<<<<<<<< The bean class here

    public static void main(String[] args) {
        new BeanBuilderWriter()
                .generator(new BgenDemoGenerator())
                .addMapping("", "") // Catch all mapping to same package
                .write(BEAN_CLS);
    }

    /**
     * Add the custom parent class for the builder.
     */
    @Override
    protected String getBuilderParent(Class beanCls, String builderType) {
        String parentName = BgenUtil.className(BgenDemoConstruct.Parent.class);
        return parentName + "<" + builderType + ">";
    }
}
